"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
require('dotenv-extended').config();
const fs_1 = __importDefault(require("fs"));
const express_1 = __importDefault(require("express"));
const express_graphql_1 = __importDefault(require("express-graphql"));
const lru_cache_1 = __importDefault(require("lru-cache"));
const web3_eth_1 = require("web3-eth");
const web3_providers_1 = require("web3-providers");
const melonjs_1 = require("@melonproject/melonjs");
const _1 = require("./");
const loaders = __importStar(require("./loaders"));
(() => __awaiter(void 0, void 0, void 0, function* () {
    const eth = new web3_eth_1.Eth(new web3_providers_1.HttpProvider(process.env.MELON_ENDPOINT));
    const network = yield eth.net.getId();
    const deployment = JSON.parse(fs_1.default.readFileSync(process.env.MELON_DEPLOYMENT, 'utf8'));
    const environment = new melonjs_1.DeployedEnvironment(eth, network, deployment, {
        cache: new lru_cache_1.default(500),
    });
    const schema = _1.createSchema(environment);
    const server = express_graphql_1.default(() => __awaiter(void 0, void 0, void 0, function* () {
        const block = yield environment.client.getBlockNumber();
        const context = {
            block,
            environment,
            loaders: {},
        };
        Object.keys(loaders).forEach(key => {
            // @ts-ignore
            context.loaders[key] = loaders[key](context);
        });
        return {
            schema,
            graphiql: true,
            context,
        };
    }));
    const app = express_1.default();
    app.use('/', server);
    app.listen(4000);
}))();
